package lawOfDemeter;

import org.aspectj.lang.reflect.*;
import org.aspectj.lang.*;
import testcase.*;            // general tests

/**
 * @author Paul Freeman
 */

privileged aspect Tests {

  public static void main(String[] args){
    ATest();
    OriginalFooTest();
    OldImmediatePartTest();
  }

  pointcut specificRun():
    call(* *Test*(..)) && cflow(execution(public static void Tests.main(String[])));

  void around(): Tests.specificRun(){
    System.out.println("*** running " +
      ((MethodSignature)thisJoinPointStaticPart.getSignature()).getName() +
      " ***");
    proceed();
    System.out.println("");
  }

  public static void ATest(){
    testcase.Main.main(new String[0]);
  }

  public static void OriginalFooTest(){
    testcase.Foo.main(new String[0]);
  }

  public static void OldImmediatePartTest(){
    testcase.LinkedList.main(new String[0]);
  }
}